#! /usr/bin/perl

my %params;

$size_of_form_info = $ENV{'CONTENT_LENGTH'};
read (STDIN, $form_info, $size_of_form_info);

foreach $pair (split (/&/, $form_info))
{
    ($key, $value) = split (/=/, $pair);
    $key =~ tr/+/ /;
    $key =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $params{$key} = $value;
}

# Take out characters the user entered that happened to also be our delimiters
while (($key, $value) = each(%params))
{
    $params{$key} =~ s/\|/\,/g;
    $params{$key} =~ s/\[/\(/g;
    $params{$key} =~ s/\]/\)/g;
}

open HANDLE, ">>../htdocs/evaluation/careerdata.txt";
open CSV, ">>../htdocs/evaluation/careerdata.csv";

@t = localtime(time);

print HANDLE "\n****** Submitted: ".$t[2].":".$t[1].":".$t[0]." ".($t[4]+1)."/".$t[3]."/".($t[5]+1900)." ******\n";
print CSV ($t[4]+1)."/".$t[3]."/".($t[5]+1900)."|";

# Contact Information
print HANDLE "Name: ".$params{"Name"}."\n";
print HANDLE "Phone: ".$params{"Phone"}."\n";
print HANDLE "Address: ".$params{"Address"}."\n";
print HANDLE "Email: ".$params{"Email"}."\n";
print HANDLE "City: ".$params{"City"}."\n";
print HANDLE "State: ".$params{"State"}."\n";
print HANDLE "Zip: ".$params{"Zip"}."\n";
print HANDLE "Title: ".$params{"Title"}."\n";
print HANDLE "Organization: ".$params{"Organization"}."\n";
print CSV $params{"Name"}."|";
print CSV $params{"Phone"}."|";
print CSV $params{"Address"}."|";
print CSV $params{"Email"}."|";
print CSV $params{"City"}."|";
print CSV $params{"State"}."|";
print CSV $params{"Zip"}."|";
print CSV $params{"Title"}."|";
print CSV $params{"Organization"}."|";

# Question 1
print HANDLE "Familiarity with geospatial technologies: ".$params{"Q1"}."\n";
print CSV $params{"Q1"}."|";

# Question 2
print HANDLE "Interested in site because you are a: ";
while (($key, $value) = each(%params))
{
    if ($key eq "Q0207")
    {
        print HANDLE $params{"Q02OtherText"}.", ";
        print CSV $params{"Q02OtherText"}.", ";
    }
    elsif ($key ne "Q02OtherText" && $key =~ /Q02/)
    {
        print HANDLE $value.", ";
        print CSV $value.", ";
    }
}
print HANDLE "\n";
print CSV "|";

# Question 3
print HANDLE "Has the site helped in deciding on career goals: ".$params{"Q3"}."\n";
print CSV $params{"Q3"}."|";

# Question 4
print HANDLE "Has the site helped in deciding on educational plans: ".$params{"Q4"}."\n";
print CSV $params{"Q4"}."|";

# Question 5
print HANDLE "More likely to consider career in geospatial technologies: ".$params{"Q5"}."\n";
print CSV $params{"Q5"}."|";

# Question 6
print HANDLE "More likely to consider education in geospatial technologies: ".$params{"Q6"}."\n";
print CSV $params{"Q6"}."|";

# Question 7
print HANDLE "Does site provide information to advice youth career decisions: ".$params{"Q7"}."\n";
print CSV $params{"Q7"}."|";

# Question 8
$params{"Q8"} =~ s/\r/ /g;
$params{"Q8"} =~ s/\n/ /g;
print HANDLE "Like most about the site: ".$params{"Q8"}."\n";
print CSV $params{"Q8"}."|";

# Question 9
$params{"Q9"} =~ s/\r/ /g;
$params{"Q9"} =~ s/\n/ /g;
print HANDLE "Improve on the site: ".$params{"Q9"}."\n";
print CSV $params{"Q9"}."|";

# Question 10
print HANDLE "State/province: ".$params{"Q10"}."\n";
print CSV $params{"Q10"}."|";

# Question 11
$params{"Q11"} =~ s/\r/ /g;
$params{"Q11"} =~ s/\n/ /g;
print HANDLE "Other Country: ".$params{"Q11"}."\n";
print CSV $params{"Q11"}."|";

# Question 12
print HANDLE "Learned about the site from: ";
while (($key, $value) = each(%params))
{
    if ($key eq "Q1207")
    {
        print HANDLE $params{"Q12OtherText"}.", ";
        print CSV $params{"Q12OtherText"}.", ";
    }
    elsif ($key ne "Q12OtherText" && $key =~ /Q12/)
    {
        print HANDLE $value.", ";
        print CSV $value.", ";
    }
}
print HANDLE "\n";
print CSV "|";

# Question 13
$params{"Q13"} =~ s/\r/ /g;
$params{"Q13"} =~ s/\n/ /g;
print HANDLE "Additional Comments: ".$params{"Q13"}."\n";
print CSV $params{"Q13"}."|\n";

print "Content-type: text/html\n\n";
print "<center><h3>Thanks for providing feedback.</h3>";
print "<a href=\"http://www.geospatialcareers.net/\">Return to MapPros</a></center>\n";
